#!/bin/sh

ResourceTree="../../exampleResourceTree"

# Script to test access to the TEST resource tree

echo "********************************************"
echo "$0: checking access of User I to TEST..."
$AKENTI_HOME/bin/akenti CA -q -x $ResourceTree/idCerts/userICert.pem -f $ResourceTree/conf/Akenti.conf -r TEST
ret_val=$?
echo "$0: should have seen Allowed actions are: read"
echo "********************************************"
if [ ! "${ret_val}" = "0" ]; then exit ${ret_val}; fi

echo
echo
echo "********************************************"
echo "$0: checking access of User II to TEST..."
$AKENTI_HOME/bin/akenti CA -q -x $ResourceTree/idCerts/userIICert.pem -f $ResourceTree/conf/Akenti.conf -r TEST
ret_val=$?
echo "$0: should see Allowed actions are: read"
echo "********************************************"
if [ ! "${ret_val}" = "0" ]; then exit ${ret_val}; fi

echo
echo
echo "********************************************"
echo "$0: checking access of user I to TEST/test1..."
$AKENTI_HOME/bin/akenti CA -q -x $ResourceTree/idCerts/userICert.pem -f $ResourceTree/conf/Akenti.conf -r TEST/test1
ret_val=$?
echo "$0: should see Allowed actions are: not allowed"
echo "********************************************"
if [ ! "${ret_val}" = "1" ]; then exit ${ret_val}; fi

echo
echo
echo "********************************************"
echo "$0: checking access of User II to TEST/test1..."
$AKENTI_HOME/bin/akenti CA -q -x $ResourceTree/idCerts/userIICert.pem -f $ResourceTree/conf/Akenti.conf -r TEST/test1
ret_val=$?
echo "$0: should see Allowed actions are: read, write"
echo "********************************************"
if [ ! "${ret_val}" = "0" ]; then exit ${ret_val}; fi

echo
echo
echo "********************************************"
echo "$0: checking access of user I to TEST/test2..."
$AKENTI_HOME/bin/akenti CA -q -x $ResourceTree/idCerts/userICert.pem -f $ResourceTree/conf/Akenti.conf -r TEST/test2
ret_val=$?
echo "$0: should see Allowed actions are: execute, read, write"
echo "********************************************"
if [ ! "${ret_val}" = "0" ]; then exit ${ret_val}; fi

echo
echo
echo "********************************************"
echo "$0: checking access of User II to TEST/test2..."
$AKENTI_HOME/bin/akenti CA -q -x $ResourceTree/idCerts/userIICert.pem -f $ResourceTree/conf/Akenti.conf -r TEST/test2
ret_val=$?
echo "$0: should see Allowed actions are: execute, read,"
echo "********************************************"
if [ ! "${ret_val}" = "0" ]; then exit ${ret_val}; fi
