package lbl.akenti.dirServices;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.URL;
import java.util.ArrayList;

/**
  * Class <code>HttpCertificateRetrieval</code> loads certificates from 
  * web directories.
  * 
  * @author  Abdelilah Essiari
  * @see     lbl.akenti.certs.AkentiCertificate
  * @see     lbl.akenti.certs.AkentiCertificateFactory
  * @see     lbl.akenti.util.X509CertReader
  */
final public 
class HttpCertificateRetrieval extends FileCertificateRetrieval {

  /**
    * Construct this <code>HttpCertificateRetrieval</code>.
    */ 
  public HttpCertificateRetrieval() {
  }

  /**
    * Lists files.
    */
  protected String[]
  listFiles(URL url) {
    try {
      BufferedReader 
        reader = new BufferedReader(new InputStreamReader(url.openStream()));

      ArrayList v = new ArrayList();
      String line;

      while ((line = reader.readLine()) != null) {
        if (line.indexOf("DIR") == -1) {
          int idx1 = line.indexOf("HREF=\"");

          if (idx1 != -1) {
            int idx2 = line.indexOf("\"", idx1 + 6);

            v.add(line.substring(idx1 + 6, idx2));
          }
        }
      }

      return (String[]) v.toArray(new String[0]);
    } catch(IOException ex) {
      return null;
    }
  }
}
