package lbl.akenti.dirServices;

import java.net.URL;
import java.security.cert.X509Certificate;
import java.util.Map;
import javax.naming.NamingException;
import lbl.akenti.util.LDAPSearchUtil;

/**
  * Class <code>LdapCertificateRetrieval</code> loads certificates  
  * <code>X509</code> certificates from <code>LDAP </code> directories.
  * 
  * @author  Abdelilah Essiari
  * @see lbl.akenti.util.X509CertReader
  * @see lbl.akenti.util.LDAPSearchUtil
  */
final public 
class LdapCertificateRetrieval extends CertificateRetrieval {

  /**
    * Construct this <code>CertificateRetrieval</code>.
    */
  public LdapCertificateRetrieval() {
  }

  /**
    * Retrieves <code>X509Certificate</code>s.
    */
  public X509Certificate[] 
  retrieveX509Certificates(URL url, Map args) {
    try {
      String base = (String) args.get("base");

      url = new URL("ldap", url.getHost(), url.getPort(), base);
      X509Certificate[] certs = LDAPSearchUtil.loadX509Certs(url, "cn=*");
      return certs;
    } catch(RuntimeException ex) {
      throw ex;
    } catch(Exception ex) {
      return new X509Certificate[0];
    }
  }
}
