package lbl.akenti.disp;

/*
 * A class to contain the constants used by the ResrcDispController class
 */
public interface ResrcDispConsts {
    
    // Indices for accessing the controller's frames
    public static final int RESOURCE_INDEX = 0;
    public static final int POL_UC_INDEX = 1;

    static final String[] TITLES = {
        "Resource Info",
        "Policy / UseCondition Chooser"
    } ; // end of header

    // Resource Frame
    public static String RESOURCE_HEADER =
        "<html><font size=+1 color=blue>" + TITLES[RESOURCE_INDEX] +
	"<li><font color=blue>Enter the name of the resource." +
	"<li><font color=blue>Enter the base url."
	; // end of header

    // Resource / UseCondition chooser Frame - TODO
    public static String POL_UC_HEADER =
	"<html><font size=+1 color=blue>" + TITLES[POL_UC_INDEX] +
	""; // end of header


    // CONVENIENT ARRAY OF HEADERS
    static final String[] HEADERS = {
	RESOURCE_HEADER,
	POL_UC_HEADER
    };

    /*
     * Help messages.  Messages are indexed in the order of frames
     */
    static final String[] helpMess = {
	// Resource frame help message
	"The resource can be hierarchical or flat.  " +
	"The relative resource name is appended to the base url " +
	"which the generator uses to find information about this resource.  " +
	"\n\nA base url, different from the default one, " +
	"can be chosen using the Create button, or be typed in.  " +
	"If you are not sure of the correct relative resource name, " +
	"clicking on the Browse button will give you a file browse window " +
	"that server controls.  The Policy Definition Server returns the " +
	"contents of the authorization file (which lists the stakeholders " +
	"for the resource) and the resource attributes file, which contains " +
	"the attributes, values, and actions that are defined for the " +
	"resource.\n\nThe host and port constitute the address of the " +
	"Policy Definition Server\nAlldefault values are read from the " +
	"AkentiGen.conf file.",

	// Policy / UseCondition chooser help message - TODO
	"Under Construction"
    };
}
