package lbl.akenti.messaging;

import javax.xml.bind.JAXBException;
import lbl.akenti.jaxb.AkentiResponseType;
import lbl.akenti.jaxb.CreateResourceResponseType;


/**
 * A sparse response to a create resource request.
 * Empty except for the AkentiMessage.
 * @author Tommaso Sciortino
 */
final public
class CreateResourceResponse extends AkentiResponse {
  
 /**
   * Constructs a <code>CreateResourceResponse</code>.
   * @param uid the id
   * @param mesg the AkentiMessage
   */
  public CreateResourceResponse(int uid, AkentiMessage mesg) {
    super(uid, mesg);
  }
  
 /**
   * Constructs this <code>CreateResourceResponse</code> from a
   * <code>CreateResourceResponseType<code>.
   * @param impl the CreateResourceRequest
   */
  public CreateResourceResponse(CreateResourceResponseType impl) {
    super(impl);
  }
  
 /**
   * Produces a CreateResourceResponseType to encapsulate the data in this object.
   * @throws JAXBException if mandatory data is not present
   * @return the CreateResourceResponseType
   */
  protected AkentiResponseType doToJAXBImpl() throws JAXBException {
    return Util.getObjectFactory().createCreateResourceResponseGenerated();
  }
}
