package lbl.akenti.messaging;

import java.io.OutputStream;
import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.Unmarshaller;
import javax.xml.bind.Validator;
import lbl.akenti.jaxb.AkentiRequestType;
import lbl.akenti.jaxb.ObjectFactory;

/**
 *
 *
 *  @author abdelilah Essiari
 *  @version $Revision: 1.5 $
 */
public final
class Util {
  private static JAXBContext context;
  private static Unmarshaller unmarshaller;
  private static Marshaller marshaller;
  private static Validator validator;
  private static ObjectFactory objFactory;
  
  private static final JAXBContext createContext() throws JAXBException {
    return JAXBContext.newInstance("lbl.akenti.jaxb");
  }
  
  public static final JAXBContext getContext() throws JAXBException {
    if (context == null) {
      context = createContext();
    }
    
    return context;
  }
  
  public static final Unmarshaller getUnmarshaller() throws JAXBException {
    if (unmarshaller == null) {
      unmarshaller = getContext().createUnmarshaller();
    }
    
    return unmarshaller;
  }
  
  public static final Marshaller getMarshaller() throws JAXBException {
    if (marshaller == null) {
      marshaller = getContext().createMarshaller();
      marshaller.setProperty(Marshaller.JAXB_FORMATTED_OUTPUT, Boolean.TRUE);
    }
    
    return marshaller;
  }
  
  public static final Validator getValidator() throws JAXBException {
    if (validator == null) {
      validator = getContext().createValidator();
    }
    
    return validator;
  }
  
  
  public static final ObjectFactory getObjectFactory() {
    if (objFactory == null) {
      objFactory = new ObjectFactory();
    }
    
    return objFactory;
  }
  
  // TODO
  // WE NEED TO REMOVE THIS FROM HERE
  public static void marshal(AkentiRequestType req, OutputStream os) throws JAXBException {
    getMarshaller().marshal(req, os);
  }
}
