package lbl.akenti.parsers;

import java.text.ParseException;

/**
  * @author Abdelilah Essiari
  */
final public 
class Expression {
  private TreeNode root;

  /**
    * Constructs this <code>Expression</code>.
    *
    * @see lbl.akenti.parsers.ExpressionParser
    */
  public Expression(String expr) throws ParseException {
    ExpressionParser parser = new ExpressionParser();

    root = parser.parseExpression(expr);
  }

  /**
    * Returns a string representation of this expression.
    */
  public String toString() {
    return root.toString();
  }

  /**
    */
  public boolean isNull() {
    return root.isNull();
  }

  /**
    */
  Expression(TreeNode root) {
    if (root == null) {
      throw new IllegalArgumentException();
    }

    this.root = root;
  }

  /**
    */
  TreeNode getRoot() {
    return root;
  }
}
