package lbl.akenti.parsers;

/**
  *
  * @author Abdelilah Essiari
  */
final public class 
Result {
  public static Result TRUE = new Result(Boolean.TRUE);
  public static Result FALSE = new Result(Boolean.FALSE);
  public static Result NULL = new Result(null);

  private Object result;

  /**
    * Constucts a null result.
    */
  public Result() {
    this(null);
  }

  /**
    * Wraps a result.
    */
  public Result(Object result) {
    this.result = result;
  }

  /**
    * Returns result.
    */
  public Object getValue() {
    return result;
  }

  /**
    * Is the result <i>true</i> 
    */
  public boolean isTrue() {
    return (result != null) && 
           (result instanceof Boolean) &&
           ((Boolean) result).booleanValue();
  }

  /**
    * Is the result <i>false</i> 
    */
  public boolean isFalse() {
    return (result != null) && 
           (result instanceof Boolean) &&
           ! ((Boolean) result).booleanValue();
  }

  /**
    * Is the result <i>null</i> 
    */
  public boolean isNull() {
    return (result == null);
  }
}
