package lbl.akenti.policyEngine;

import lbl.akenti.certs.Certificate;

/**
  *
  * @see lbl.akenti.certs.Certificate
  * @see lbl.akenti.policyEngine.CertificateHolder
  * @author Abdlelilah Essiari
  */
public interface CertificateCache {

  /**
    * Adds a certificate to the cache. The cache accepts
    * multiple certificates for the same key.
    *
    * @return a holder that wraps the certificate.
    * @see CertificateHolder
    */
  CertificateHolder addCertificate(String key, Certificate cert);
  
  /**
    */
  void addCertificateHolder(String key, CertificateHolder holder);

  /**
    * Returns the holders that map to the given <code>key</code>.
    */
  CertificateHolder[] getCertificateHolders(String key);
}
