/*
 * CertificateInfoCollector.java
 *
 * Created on July 27, 2004, 3:42 PM
 */

package lbl.akenti.policyEngine.check;

import java.util.ArrayList;
import lbl.akenti.messaging.AkentiMessage;

/**
 * This is the scratchpad which holds the info used during checkpolicy.
 * @author Tommaso Sciortino
 */
public class CertInfoCollector {
  private boolean status;
  private ArrayList certInfos;
  
  /** Creates a new instance of CertInfoCollector */
  public CertInfoCollector() {
    certInfos = new ArrayList();
    status = true;
  }
  
  public void addCertInfo(CertInfo ci) {
    certInfos.add(ci);
  }
  
  public CertInfo[] getCertInfos() {
    return (CertInfo[]) certInfos.toArray(new CertInfo[certInfos.size()]);
  }
  
  public void setCertInfos(CertInfo[] cis) {
    certInfos.clear();
    for (int i=0; i < cis.length; i++) {
      certInfos.add(cis[i]);
    }
    
  }
  
  public void addMessage(int i, AkentiMessage mesg) {
    if ( i > certInfos.size() || i < 0 ) {
      return;
    }
    
    ((CertInfo) certInfos.get(i)).addAkentiMessage(mesg);
  }
  
  public void setUsed(int i, boolean isUsed) {
    if ( i > certInfos.size() || i < 0 ) {
      return;
    }
    
    ((CertInfo) certInfos.get(i)).setUsed(isUsed);
  }
  
  public void setError(int i, boolean isError) {
    if ( i > certInfos.size() || i < 0 ) {
      return;
    }
    
    ((CertInfo) certInfos.get(i)).setError(isError);
  }
  
  public CertInfo getCertInfo(int i, boolean isError) {
    if ( i > certInfos.size() || i < 0 ) {
      return null;
    }
    
    return ((CertInfo) certInfos.get(i));
  }
  
  public void CertInfoReorder() {
    ArrayList newCertInfos = new ArrayList();
    
    for (int i=0; i < certInfos.size(); i++) {
      CertInfo p = (CertInfo) certInfos.get(i);
      
      if(p.getType().equals("dummy")) {
        newCertInfos.add(p);
      } else if (p.getType().equals("Policy")) {
        newCertInfos.add(p);
        String resource = p.getResource();
        
        for (int j = i; j < certInfos.size(); j++) {
          CertInfo uc = (CertInfo) certInfos.get(j);
          if (uc.getResource().equals(resource) && uc.getType().equals("UseCondition")) {
            newCertInfos.add(uc);
          }
        }
      }
      
    }
    
    certInfos = newCertInfos;
  }
  
  
  //XXX TODO: this is silly
  public static CertInfoCollector createCertInfoCollector() {
    return new CertInfoCollector();
  }
  
  public void setStatus(boolean status) {
    this.status = status;
  }
  
  public boolean isStatus() {
    return status;
  }
  
  //XXX TODO: here we test to make sure the type is "dummy" in c++ we check the hashcode
  public int lookup(String hash, String type) {
    if (hash.equals("dummy")) {
      return -1;
    }
    
    for (int i = 0; i < certInfos.size(); ++i) {
      CertInfo p = (CertInfo) certInfos.get(i);
      if (p.getHashCode().equals(hash) && p.getType().equals(type)) {
        return i;
      }
    }
    return -1;
  }
  
  public int lookup(String hash, String type, String uid) {
    if (hash.equals("dummy")) {
      return -1;
    }
    for (int i = 0; i < certInfos.size(); ++i) {
      CertInfo p = (CertInfo) certInfos.get(i);
      if (p.getHashCode().equals(hash) && p.getType().equals(type) &&
      p.getAkentiCertificate().getUniqueID().equals(uid) ) {
        return i;
      }
    }
    return -1;
  }
  
}
