/**
 *  Simple JOptionPane widget that uses a (optional) combo box to get input
 *  @author Jordan Thompson (JordanCThompson@yahoo.com)
 */

package lbl.akenti.policyManager.widgets;

public class ComboBoxPane extends javax.swing.JOptionPane {
    private boolean userApproved;
    // Variables declaration - do not modify
    private javax.swing.JPanel button_Panel;
    private javax.swing.JButton cancel_button;
    private javax.swing.JComboBox comboBox;
    private javax.swing.JLabel label;
    private javax.swing.JPanel main_panel;
    private javax.swing.JButton ok_button;
    // End of variables declaration
    
    public ComboBoxPane(String aLabel) {
        initComponents(aLabel);
    }
    
    private void initComponents(String aLabel) {
        setLayout(new java.awt.BorderLayout());
        
        java.awt.GridBagConstraints gridBagConstraints;
        
        main_panel = new javax.swing.JPanel();
        label = new javax.swing.JLabel();
        comboBox = new javax.swing.JComboBox();
        button_Panel = new javax.swing.JPanel();
        ok_button = new javax.swing.JButton();
        cancel_button = new javax.swing.JButton();
        
        main_panel.setLayout(new java.awt.GridBagLayout());
        
        label.setText(aLabel);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 5);
        main_panel.add(label, gridBagConstraints);
        
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints.gridheight = java.awt.GridBagConstraints.RELATIVE;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.ipadx = 200;
        main_panel.add(comboBox, gridBagConstraints);
        
        add(main_panel, java.awt.BorderLayout.CENTER);
        
        button_Panel.setLayout(new java.awt.GridBagLayout());
        
        ok_button.setText("OK");
        ok_button.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ok_buttonActionPerformed(evt);
            }
        });
        
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.insets = new java.awt.Insets(5, 0, 5, 0);
        button_Panel.add(ok_button, gridBagConstraints);
        
        cancel_button.setText("Cancel");
        cancel_button.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancel_buttonActionPerformed(evt);
            }
        });
        
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.insets = new java.awt.Insets(5, 0, 5, 0);
        button_Panel.add(cancel_button, gridBagConstraints);
        
        add(button_Panel, java.awt.BorderLayout.SOUTH);
        
        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-330)/2, (screenSize.height-178)/2, 330, 178);
    }
    
    private void cancel_buttonActionPerformed(java.awt.event.ActionEvent evt) {
        // TODO add your handling code here:
        userApproved = false;
        setValue(GenConsts.AK_CANCEL_VALUE);
    }
    
    private void ok_buttonActionPerformed(java.awt.event.ActionEvent evt) {
        // TODO add your handling code here:
        userApproved = true;
        setValue(GenConsts.AK_CANCEL_VALUE);
    }
    
    public void addItem(Object item) {
        comboBox.addItem(item);
    }
    
    public Object getSelectedItem() {
        return comboBox.getSelectedItem();
    }
    
    public boolean getUserApproved() {
        return userApproved;
    }
}
