package lbl.akenti.policyManager.widgets;

import java.awt.Color;
import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;

/**
 * Allows the user to specify the cache time for the
 * <code>policy certificate</code> being generated.
 *
 * @see LBLTextFieldFactory
 */
public class LBLCachePanel
extends LBLPanel implements DocumentListener {
  
  private JTextField cacheField;
  
  /**
   * Builds this frame.
   *
   * @param parent this window's parent
   * @param header the title of this window
   */
  public LBLCachePanel(LBLTopFrame parent, String header) {
    super(parent, header);
    
    JLabel label = new JLabel("Cache Time");
    
    label.setForeground(Color.red);
    cacheField = LBLTextFieldFactory.createNumberField(this);
    
    add(WrapUtil.wrapHorizontal(label, cacheField), "Center");
  }
  
  
  /**
   */
  public void changedUpdate(DocumentEvent e)  {
    // do nothing
  }
  
  /**
   * Called when text is inserted in the text field.
   * Enables the <code>next button</code>.
   */
  public void insertUpdate(DocumentEvent e)  {
  }
  
  /**
   * Called when text is removed from the text field.
   * May disable the <code>next button</code> off.
   */
  public void removeUpdate(DocumentEvent e) {
  }
  
  /**
   * Turns the <code>next button</code> on or off.
   */
  private void doEnable() {
  }
  
  /**
   * Returns the cache time.
   */
  public long getCacheTime() {
    return Long.valueOf(getCacheTimeAsString()).longValue();
  }
  
  /**
   * Sets the cache time.
   */
  public void setCacheTime(long cacheTime) {
    cacheField.setText(String.valueOf(cacheTime));
  }
  
  /**
   * Returns the cache time as a string.
   */
  public String getCacheTimeAsString() {
    String temp = cacheField.getText();
    
    return temp.equals("") ? "-1" : temp;
  }
  
  /**
   */
  public void clear() {
    cacheField.setText("");
  }
  
}