/**
 *  @author Jordan Thompson (JordanCThompson@yahoo.com)
 */
package lbl.akenti.policyManager.widgets;

import javax.swing.DefaultListModel;

public class ManageActionsPane extends javax.swing.JOptionPane {
    private DefaultListModel model;
    private boolean userApproved;
    // Variables declaration - do not modify
    private javax.swing.JButton add_button;
    private javax.swing.JButton cancel_button;
    private javax.swing.JPanel confirmation_panel;
    private javax.swing.JPanel control_panel;
    private javax.swing.JLabel label;
    private javax.swing.JList list;
    private javax.swing.JPanel main_panel;
    private javax.swing.JButton ok_button;
    private javax.swing.JButton remove_button;
    private javax.swing.JScrollPane sPane;
    // End of variables declaration
    
    public ManageActionsPane() {
        initComponents();
    }
    
    private void initComponents() {
        setLayout(new java.awt.BorderLayout());
        
        java.awt.GridBagConstraints gridBagConstraints;
        
        main_panel = new javax.swing.JPanel();
        sPane = new javax.swing.JScrollPane();
        
        model = new DefaultListModel();
        list = new javax.swing.JList(model);
        
        confirmation_panel = new javax.swing.JPanel();
        ok_button = new javax.swing.JButton();
        cancel_button = new javax.swing.JButton();
        control_panel = new javax.swing.JPanel();
        add_button = new javax.swing.JButton();
        remove_button = new javax.swing.JButton();
        label = new javax.swing.JLabel();
        
        main_panel.setLayout(new java.awt.GridLayout());
        
        sPane.setViewportView(list);
        
        main_panel.add(sPane);
        
        add(main_panel, java.awt.BorderLayout.CENTER);
        
        confirmation_panel.setLayout(new java.awt.GridBagLayout());
        
        ok_button.setText("OK");
        ok_button.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ok_buttonActionPerformed(evt);
            }
        });
        
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.insets = new java.awt.Insets(5, 0, 5, 0);
        confirmation_panel.add(ok_button, gridBagConstraints);
        
        cancel_button.setText("CANCEL");
        cancel_button.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancel_buttonActionPerformed(evt);
            }
        });
        
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints.insets = new java.awt.Insets(5, 0, 5, 0);
        confirmation_panel.add(cancel_button, gridBagConstraints);
        
        add(confirmation_panel, java.awt.BorderLayout.SOUTH);
        
        control_panel.setLayout(new java.awt.GridBagLayout());
        
        add_button.setText("Add");
        add_button.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                add_buttonActionPerformed(evt);
            }
        });
        
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        control_panel.add(add_button, gridBagConstraints);
        
        remove_button.setText("Remove");
        remove_button.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                remove_buttonActionPerformed(evt);
            }
        });
        
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        control_panel.add(remove_button, gridBagConstraints);
        
        add(control_panel, java.awt.BorderLayout.EAST);
        
        label.setText("Actions that will be added:");
        add(label, java.awt.BorderLayout.NORTH);
        
        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-390)/2, (screenSize.height-376)/2, 390, 376);
    }
    
    private void remove_buttonActionPerformed(java.awt.event.ActionEvent evt) {
        model.remove(list.getSelectedIndex());
    }
    
    private void add_buttonActionPerformed(java.awt.event.ActionEvent evt) {
        InputPane inputPane = new InputPane("Enter new Action: ");
        inputPane.setText("");
        inputPane.createDialog(this, "Add a new Action").setVisible(true);
        if (inputPane.getUserApproved()) {
            if (!model.contains(inputPane.getText())) {
                model.addElement(inputPane.getText());
            }
        }
    }
    
    private void cancel_buttonActionPerformed(java.awt.event.ActionEvent evt) {
        userApproved = false;
        setValue(GenConsts.AK_CANCEL_VALUE);
    }
    
    private void ok_buttonActionPerformed(java.awt.event.ActionEvent evt) {
        userApproved = true;
        setValue(GenConsts.AK_CANCEL_VALUE);
    }
    
    public void addList(String[] aList) {
        for (int x = 0; x < aList.length; x++) {
            if (!model.contains(aList[x])) {
                model.addElement(aList[x]);
            }
        }
    }
    
    public String[] getList() {
        String [] listOfItems = new String[model.getSize()];
        for (int x = 0; x < model.getSize(); x++) {
            listOfItems[x] = (String) model.get(x);
        }
        return listOfItems;
    }
    public boolean getUserApproved() {
        return userApproved;
    }
}



