/**
 *  @author Jordan Thompson (JordanCThompson@yahoo.com)
 */

package lbl.akenti.policyManager.widgets;
import javax.swing.JFileChooser;
import javax.swing.*;

public class P12Retriever extends javax.swing.JOptionPane {
    private boolean userApproved;
    // Variables declaration - do not modify
    private javax.swing.JButton browse_button;
    private javax.swing.JPanel button_panel;
    private javax.swing.JButton cancel_button;
    private javax.swing.JPanel input_panel;
    private javax.swing.JButton ok_button;
    private javax.swing.JLabel p12_label;
    private javax.swing.JTextField p12_textfield;
    private javax.swing.JPasswordField password_field;
    private javax.swing.JLabel password_label;
    // End of variables declaration
    
    public P12Retriever() {
        initComponents();
    }
    
    private void initComponents() {
        setLayout(new java.awt.BorderLayout());
        
        java.awt.GridBagConstraints gridBagConstraints;
        
        button_panel = new javax.swing.JPanel();
        ok_button = new javax.swing.JButton();
        cancel_button = new javax.swing.JButton();
        input_panel = new javax.swing.JPanel();
        p12_label = new javax.swing.JLabel();
        p12_textfield = new javax.swing.JTextField();
        browse_button = new javax.swing.JButton();
        password_label = new javax.swing.JLabel();
        password_field = new javax.swing.JPasswordField();
        
        button_panel.setLayout(new java.awt.GridBagLayout());
        
        ok_button.setText("OK");
        ok_button.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ok_buttonActionPerformed(evt);
            }
        });
        
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.SOUTH;
        button_panel.add(ok_button, gridBagConstraints);
        
        cancel_button.setText("Cancel");
        cancel_button.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancel_buttonActionPerformed(evt);
            }
        });
        
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        button_panel.add(cancel_button, gridBagConstraints);
        
        add(button_panel, java.awt.BorderLayout.SOUTH);
        
        input_panel.setLayout(new java.awt.GridBagLayout());
        
        p12_label.setText("P12 File:");
        input_panel.add(p12_label, new java.awt.GridBagConstraints());
        
        p12_textfield.setColumns(15);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.ipadx = 26;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTH;
        input_panel.add(p12_textfield, gridBagConstraints);
        
        browse_button.setAlignmentX(0.5F);
        browse_button.setLabel("Browse");
        browse_button.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                browse_buttonActionPerformed(evt);
            }
        });
        
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        input_panel.add(browse_button, gridBagConstraints);
        
        password_label.setText("Password:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        input_panel.add(password_label, gridBagConstraints);
        
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        input_panel.add(password_field, gridBagConstraints);
        
        add(input_panel, java.awt.BorderLayout.CENTER);
        
        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-377)/2, (screenSize.height-179)/2, 377, 179);
        
    }
    
    private void cancel_buttonActionPerformed(java.awt.event.ActionEvent evt) {
        userApproved = false;
        setValue(GenConsts.AK_CANCEL_VALUE);
    }
    private void ok_buttonActionPerformed(java.awt.event.ActionEvent evt) {
        userApproved = true;
        setValue(GenConsts.AK_CANCEL_VALUE);
    }
    
    private void browse_buttonActionPerformed(java.awt.event.ActionEvent evt) {
        JFileChooser fileChooser = new JFileChooser();
        fileChooser.setDialogTitle("Select the P12 you want to use");
        fileChooser.setFileSelectionMode(JFileChooser.FILES_ONLY);
        int clientResponse = fileChooser.showDialog(this, "Select");
        
        if (clientResponse == fileChooser.APPROVE_OPTION) {
            p12_textfield.setText(fileChooser.getSelectedFile().getAbsolutePath());
        }
    }
    
    public boolean getUserApproved() {
        return userApproved;
    }
    public String getP12AbsolutePath() {
        return p12_textfield.getText();
    }
    
    public char[] getP12Password() {
        return password_field.getPassword();
    }
}


