/**
 * @author  Jordan C Thompson (JordanCThompson@gmail.com)
 */
package lbl.akenti.policyManager.widgets;

import java.net.URL;

public class SplashScreen extends javax.swing.JOptionPane {
    
    private static URL FILE_URL;
    
    // Variables declaration - do not modify
    private javax.swing.JPanel button_panel;
    private javax.swing.JCheckBox checkBox;
    private javax.swing.JEditorPane editorPane;
    private javax.swing.JPanel main_panel;
    private javax.swing.JButton ok_button;
    private javax.swing.JScrollPane sPane;
    // End of variables declaration
    
    public SplashScreen(URL url) {
        FILE_URL = url;
        initComponents();
    }
    
    private void initComponents() {
        setLayout(new java.awt.BorderLayout());
        
        main_panel = new javax.swing.JPanel();
        checkBox = new javax.swing.JCheckBox();
        button_panel = new javax.swing.JPanel();
        ok_button = new javax.swing.JButton();
        sPane = new javax.swing.JScrollPane();
        editorPane = new javax.swing.JEditorPane();

        main_panel.setLayout(new java.awt.BorderLayout());

        checkBox.setSelected(true);
        checkBox.setText("Show this message in the future");
        main_panel.add(checkBox, java.awt.BorderLayout.NORTH);

        button_panel.setLayout(new java.awt.GridBagLayout());

        ok_button.setText("OK");
        ok_button.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ok_buttonActionPerformed(evt);
            }
        });

        button_panel.add(ok_button, new java.awt.GridBagConstraints());

        main_panel.add(button_panel, java.awt.BorderLayout.CENTER);

        add(main_panel, java.awt.BorderLayout.SOUTH);

        editorPane.setEditable(false);
        editorPane.setContentType("text/html");
        loadHTMLFile(FILE_URL);
        editorPane.setCaretPosition(0);
        sPane.setViewportView(editorPane);

        add(sPane, java.awt.BorderLayout.CENTER);
    }
    
    private void ok_buttonActionPerformed(java.awt.event.ActionEvent evt) {
        setValue(new Boolean(checkBox.isSelected()));
    }
    
    public void loadHTMLFile(java.net.URL url) {
        try {            
            editorPane.setPage(url);
        } catch (java.net.MalformedURLException e) {
            e.printStackTrace();
        } catch (java.io.IOException e) {
            e.printStackTrace();
        }
            
    }
    
    public boolean getSplashScreen() {
        return checkBox.isSelected();
    }    
}


