package lbl.akenti.policyManager.widgets.attr;

import javax.swing.JPanel;

import javax.swing.event.DocumentListener;
import javax.swing.event.DocumentEvent;

import lbl.akenti.policyManager.widgets.LBLPanel;
import lbl.akenti.policyManager.widgets.LBLPrincipalPane;

import lbl.akenti.certs.elements.AkentiPrincipal;

import lbl.akenti.util.ParsingException;

import lbl.akenti.policyManager.widgets.LBLTopFrame;

public class AtUserPanel extends LBLPanel implements DocumentListener {
    
    private LBLPrincipalPane principalPane;
    
    public AtUserPanel(LBLTopFrame parent, String header) {
        super(parent, header);
        
        principalPane = new LBLPrincipalPane(null);
        principalPane.setDocumentListener(this);
        add(principalPane, "Center");
    }
    
    /**
     */
    public void changedUpdate(DocumentEvent e)  {
        doEnable();
    }
    
    /**
     */
    public void insertUpdate(DocumentEvent e)  {
        doEnable();
    }
    
    /**
     */
    public void removeUpdate(DocumentEvent e) {
        doEnable();
    }
    
    public AkentiPrincipal getAkentiPrincipal() {
        try {
            return principalPane.getAkentiPrincipal();
        } catch(ParsingException ex) {
            return null;
        }
    }
    
    /**
     * Used to be private, changed to public so that I can turn off the Next button
     */
    public void doEnable() {
        if (getAkentiPrincipal() != null) {
            enableBlueButton("Next");
        } else {
            disableBlueButton("Next");
        }
    }
    
    /**
     */
    public void clear() {
        principalPane.clear();
    }
}
