package lbl.akenti.policyManager.widgets.viewer;

public interface ResrcViewConsts {
    
    // Indices for accessing the controller's frames
    public static final int RESOURCE_INDEX = 0;
    public static final int POL_UC_INDEX = 1;

    static final String[] TITLES = {
        "Resource Info",
        "Policy / UseCondition Chooser"
    } ; // end of header

    // Resource Frame
    public static String RESOURCE_HEADER =
        "<html><font size=+1 color=blue>" + TITLES[RESOURCE_INDEX] +
	"<li><font color=blue>Enter the name of the resource." +
	"<li><font color=blue>Enter the base url."
	; // end of header

    // Resource / UseCondition chooser Frame - TODO
    public static String POL_UC_HEADER =
	"<html><font size=+1 color=blue>" + TITLES[POL_UC_INDEX] +
	""; // end of header


    // CONVENIENT ARRAY OF HEADERS
    static final String[] HEADERS = {
	RESOURCE_HEADER,
	POL_UC_HEADER
    };

    /*
     * Help messages.  Messages are indexed in the order of frames
     */
    static final String[] helpMess = {
	// Resource frame help message
	"Resources can be arranged in a hierarchy (R1/T2/F) or not (R1).\n\n" +
        
	"A base url different from the default one can be made using the " +
        "Create button, or can just be typed in. If you are not sure of " +
        "the correct resource name, try clicking on the Browse button. \n\n" +
        
        "The Akenti Server returns the contents of the authorization file " +
        "(which lists the stakeholders for the resource) and the resource " +
        "attributes file (which contains the attributes, values, and " +
        "actions that are defined for the resource.)\n\n" +
        
        "The host and port constitute the address of the Akenti Server.\n" +
        "History files are kept in .akenti. For local resource browsing " +
        "(using file: protocol), a configuration file must be loaded by " +
        "going to Preferences->Load Configuration File.",

	// Policy / UseCondition chooser help message - TODO
	"Click on a resource to view it's Policy certificate. When a resource is " +
        "selected it's UseCondition certificates will appear in the field below." 
    };
}
