package lbl.akenti.servers.CacheManager;

import java.util.HashMap;
import java.util.LinkedList;
import java.util.Collection;

/**
  * 
  *
  * @see CacheEntry
  **/

public class Cache implements java.io.Serializable {
  
  private static HashMap caches = new HashMap();

  private String name;

  private HashMap map = new HashMap();

  private LinkedList list = new LinkedList();
  
  /**
    *
    */
  public Cache(String name) {
    if (name == null) {
      throw new IllegalArgumentException();
    }

    this.name = name;
  }
  
  /**
    *
    */
   
  public String getName() {
    return name;
  }

  /**
    *
    */
  public void addCacheEntry(CacheEntry e) {
    removeCacheEntry(e);
    map.put(e.getKey(), e);
    
    int index;

    for (index = 0; index < list.size(); ++index) {
      if (e.compareTo((CacheEntry) list.get(index)) <= 0) {
        break;
      } 
    }

    list.add(index, e);
  }
  
  /**
    *
    */
  public CacheEntry firstCacheEntry() {
    return list.isEmpty() ? null : (CacheEntry) list.getFirst();
  }

  /**
    *
    */
  public CacheEntry getCacheEntry(String key) {
    return (CacheEntry) map.get(key);
  }

  /**
    *
    */
  public void removeCacheEntry(CacheEntry e) {
    list.remove(map.remove(e.getKey()));
  }

  /**
    *
    */
  public String toString() {
    String ret = "[";

    ret += name;
    ret += ",";
    ret += list.toString();
    ret += "]";
    return ret;
  }

  public static Cache getCache(String name) {
    synchronized(caches) {
      Cache cache = (Cache) caches.get(name);
      
      if (cache == null) {
        caches.put(name, cache = new Cache(name));
      }

      return cache;
    }
  }
  
  public static Cache[] getCaches() {
    Collection c;

    synchronized(caches) {
      c = caches.values();
    }
    
    Cache[] caches = new Cache[c.size()];
    
    c.toArray(caches);
    return caches;
  }
}

