package lbl.akenti.util;

import java.io.File;
import java.net.InetAddress;
import java.net.UnknownHostException;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.util.Date;

public class Util {
  
  /**
    */
  private Util() {
  }

  public static String createHashName(String data) {
    return createHashName(data.getBytes());
  }

  /**
    */
  public static String createHashName(byte[] data) {
    try {
       MessageDigest md = MessageDigest.getInstance("MD5");

       md.update(data);

       byte md5[] = md.digest();
       long hash = (long)md5[0] & 0x000000ffL;

       hash = hash | (((long)md5[1]<<8L) & 0x0000ffffL);
       hash = hash | (((long)md5[2]<<16L) & 0x00ffffffL);
       hash = hash | (((long)md5[3]<<24L) & 0xffffffffL);

       String hashcode = Long.toString(hash, 16);

       int len = hashcode.length();

       if (len == 8) {
         return hashcode;
       }
       
       StringBuffer sb = new StringBuffer("00000000");

       sb.replace(8 - len, 8, hashcode);
       return sb.toString();
    } catch (NoSuchAlgorithmException e) {
      throw new RuntimeException("NoSuchAlgorithmException caught for MD5");
    }
  }

  /**
    */
  public static String createUniqueID(String hash) {
    StringBuffer sb = new StringBuffer();

    try {
      sb.append(InetAddress.getLocalHost().getHostName());
      sb.append('#');
    } catch(UnknownHostException ex) { }

    sb.append(hash);
    sb.append('#');
    sb.append(new Date());
    return sb.toString();
  }

  /**
    */
  public static String createFileName(String fileName) {
    if (!fileName.endsWith(".")) {
      fileName += '.';
    }

    int i = 0;
    File temp = new File(fileName + i);

    while (temp.exists()) {
      temp = new File(fileName + ++i);
    } 
    
    return temp.getAbsolutePath();
  }
}
